#include "../std.h"
#include "../files/info_files.h"
#include "../misc/log_time.h"
#include "environment.h"

string globus_loc;
string globus_scripts_loc;
string nordugrid_loc;
string nordugrid_bin_loc;
string nordugrid_config_loc;
string support_mail_address;
string globus_gridmap;

bool read_env_vars(bool guess) {
  char* tmp;
  tmp=getenv("GLOBUS_LOCATION");
  if((tmp == NULL) || (strlen(tmp) == 0)) {
    if(!guess) {
      olog<<"Error: GLOBUS_LOCATION environment variable not defined"<<endl;
      return false;
    }
    else {
      tmp="/opt/globus";
    };
  };
  globus_loc=tmp; globus_scripts_loc=globus_loc+"/libexec";
  tmp=getenv("NORDUGRID_LOCATION");
  if((tmp == NULL) || (strlen(tmp) == 0)) {
    if(!guess) {
      olog<<"Error: NORDUGRID_LOCATION environment variable not defined"<<endl;
      return false;
    }
    else {
      tmp="/opt/nordugrid";
    };
  };
  nordugrid_loc=tmp; nordugrid_bin_loc=nordugrid_loc+"/bin";
  nordugrid_config_loc=nordugrid_loc+"/etc/grid-manager.conf";
  if(!job_mark_check(nordugrid_config_loc)) {
    nordugrid_config_loc="/etc/grid-manager.conf";
    if(!job_mark_check(nordugrid_config_loc)) {
      olog<<"Error: grid-manager.conf configuration file is missing"<<endl;
      return false;
    };
  };
  if(support_mail_address.length() == 0) {
    char hn[100];
    support_mail_address="grid.manager@";
    if(gethostname(hn,99) == 0) {
      support_mail_address+=hn;
    }
    else {
      support_mail_address+="localhost";
    };
  };
  tmp=getenv("GRIDMAP");
  if((tmp == NULL) || (strlen(tmp) == 0)) {
    globus_gridmap="/etc/grid-security/grid-mapfile";
  }
  else { globus_gridmap=tmp; };
  return true;
}

