#include "httpsd.h"

#include "logger/logger_soapH.h"

#include <mysql/mysql.h>

class HTTP_Logger: public HTTP_Service {
 friend int nl__add(struct soap *,nl__jobinfo *,int &);
 friend int nl__get(soap*,char*,ULONG64,array_jobinfo&);
 private:
  HTTPS_Connector *c;
  struct soap sp;
  bool ignore_output;
  bool plain_post;

  bool acl_read;
  bool acl_write;

  MYSQL sql;

  static int local_fsend(struct soap *sp, const char* buf, size_t l);
  static size_t local_frecv(struct soap* sp, char* buf, size_t l);
  static int local_parse(struct soap *sp);
 
 public:
  HTTP_Logger(HTTPS_Connector *c,bool acl_read,bool acl_write);
  virtual ~HTTP_Logger(void);
  virtual HTTP_Error get(int &keep_alive);
  virtual HTTP_Error put(int &keep_alive);
  virtual HTTP_Error post(int &keep_alive);
};

HTTP_Service* logger_service_creator(HTTPS_Connector& c,const char* uri,void* arg);
void* logger_service_configurator(istream& f,const char* uri);
