#include "../../std.h"

#include "../../misc/log_time.h"
#include "../../auth/auth.h"

#include "../httpsd.h"

HTTP_Service::HTTP_Service(void) {
}

HTTP_Service::~HTTP_Service(void) {
}

HTTP_Error HTTP_Service::get(int &keep_alive) {
  olog<<"HTTP_Service: virtual get"<<endl;
  return HTTP_NOT_IMPLEMENTED;
}

HTTP_Error HTTP_Service::put(int &keep_alive) {
  olog<<"HTTP_Service: virtual put"<<endl;
  return HTTP_NOT_IMPLEMENTED;
}

HTTP_Error HTTP_Service::post(int &keep_alive) {
  olog<<"HTTP_Service: virtual post"<<endl;
  return HTTP_NOT_IMPLEMENTED;
}





bool HTTP_Service_description::match(const char* u) {
  return (strcmp(u,uri.c_str()) == 0);
}

HTTP_Service* HTTP_Service_description::create(HTTPS_Connector& c) {
  return (*creator)(c,uri.c_str(),arg);
}

HTTP_Service_description::HTTP_Service_description(const char* u,service_creator c,void* a):uri(u),arg(a) {
  creator=c;
}





HTTP_Services::HTTP_Services(void) {
  pthread_mutex_init(&lock,NULL);
}

HTTP_Services::~HTTP_Services(void) {
  pthread_mutex_destroy(&lock);
}

bool HTTP_Services::add(const char* u,service_creator c,void* arg) {
  pthread_mutex_lock(&lock);
  desc.push_back(HTTP_Service_description(u,c,arg));
  pthread_mutex_unlock(&lock);
}

bool HTTP_Services::remove(const char* u,service_creator c) {
  pthread_mutex_lock(&lock);

/* !!!!!!!!!!!!!! TODO !!!!!!!!!!!!!!! */


  pthread_mutex_unlock(&lock);
}

HTTP_Service* HTTP_Services::get(HTTPS_Connector& c,const char* u) {
  pthread_mutex_lock(&lock);
  for(list<HTTP_Service_item>::iterator i = serv.begin();i!=serv.end();++i) {
    if((strcmp(i->uri.c_str(),u)==0) && (i->con == &c)) {
      HTTP_Service* s = i->serv;
      pthread_mutex_unlock(&lock);
      return s;
    };
  };
  for(list<HTTP_Service_description>::iterator i = desc.begin();i!=desc.end();++i) {
    if(i->match(u)) {
      HTTP_Service* s = i->create(c);
      if(s == NULL) break;
      serv.push_back(HTTP_Service_item(&c,u,s)); 
      pthread_mutex_unlock(&lock);
      return s; 
    };
  };
  pthread_mutex_unlock(&lock);
  return NULL;
}

void HTTP_Services::close(const HTTPS_Connector& c) {
  pthread_mutex_lock(&lock);
  for(list<HTTP_Service_item>::iterator i = serv.begin();i!=serv.end();) {
    if(i->con == &c) {
      delete (i->serv);
      i=serv.erase(i);
    } else { ++i; };
  };
  pthread_mutex_unlock(&lock);
}


