#include "../std.h"
#include "escaped.h"

void make_escaped_string(string &str,char e) {
  int n,nn;
  for(nn=0;;) {
    if((n=str.find('\\',nn)) == string::npos) break;
    str.insert(n,"\\",1); nn=n+2;
  };
  for(nn=0;;) {
    if((n=str.find(e,nn)) == string::npos) break;
    str.insert(n,"\\",1); nn=n+2;
  };
}

/* value of e is also treated as end of string */ 
char* make_unescaped_string(char* str,char e) {
  size_t l = 0;
  char* s_end = str;
  if(e == 0) { l=strlen(str); s_end=str+l; }
  else {
    for(;str[l];l++) {
      if(str[l] == '\\') { l++; if(str[l] == 0) break; };
      if(e) { if(str[l] == e) { s_end=str+l+1; str[l]=0; break; }; };
    };
  };
  if(l==0) return s_end;
  char* p  = str;
  char* p_ = str;
  for(;*p;) {
    if((*p) == '\\') {
      p++; if((*p) == 0) p--;
    };
    (*p_)=(*p); p++; p_++;
  };
  return s_end;
}

int input_escaped_string(const char* buf,string &str,char separator,char quotes) {
  int i,ii;
  for(i=0;buf[i]==' ';i++); /* skip initial spaces */
  ii=i;
  if((quotes) && (buf[i] == quotes)) {
    char* e = strchr(buf+ii+1,quotes);
    if(e) {
      ii++; i=e-buf;
      str.append(buf+ii,i-ii);
      return (i+1);
    };
  };
  for(;;) {
    for(;(buf[i]!='\\') && (buf[i]!=separator) && (buf[i]!=0);i++);
    if(buf[i]=='\\') {
      str.append(buf+ii,i-ii); i++;
      if(buf[i]==0) {
        str.append(1,'\\'); break;
      }
      else {
        str.append(1,buf[i]); i++; ii=i;
      };
    }
    else {   /* end of word/string */
      str.append(buf+ii,i-ii);
      break;
    };
  };
  return i;
}

