#include <string>
#include <list>
#include "../files/info_types.h"
#include "replica.h"

class FileDataRC: public FileData {
 public:
  typedef list<FileDataRC>::iterator iterator;
  int try_url;    /* which one of url to try */
  string rc_url;  /* url of RC if it is RC */
  string canonic_url; /* use this url to mark files in cacche */
  list<RCLocation> *locs; /* locations to which rc url is resolved */
  FileDataRC() {
    rc_url=""; locs=NULL; try_url=0; canonic_url="";
  };
  FileDataRC(const FileDataRC& fd) { 
    *((FileData*)this) = *((FileData*)(&fd));
    locs=fd.locs; rc_url=fd.rc_url; 
    try_url=fd.try_url; canonic_url=fd.canonic_url;
  };
  FileDataRC(const FileData& fd) { 
    *((FileData*)this) = *((FileData*)(&fd));
    locs=NULL; rc_url=""; try_url=0; canonic_url="";
  };
};

bool convert_url(string &url,FileDataRC &fd,UrlMap &url_map,bool existing = true,bool non_existing = true,RCFile *ex_file = NULL);

