#include <features.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <globus_common.h>
#include <globus_error.h>
#include <globus_ftp_client.h>
#include <globus_ftp_control.h>
#include <globus_object.h>
#include <iostream>

#include "../misc/inttostring.h"
#include "ftpsubmit.h"

#define GLOBUS_ERROR GLOBUS_ERROR_NO_INFO

static int callback_status;
#define CALLBACK_NOTREADY 0
#define CALLBACK_DONE 1
#define CALLBACK_ERROR 2
static globus_mutex_t wait_m;
static globus_cond_t wait_c;
  globus_ftp_control_handle_t hctrl;

static void resp_callback(void *arg,globus_ftp_control_handle_t *h,globus_object_t *error,globus_ftp_control_response_t *response);
static int wait_for_callback(void);
globus_ftp_control_response_class_t send_command(globus_ftp_control_handle_t *hctrl,char* command,char* arg,char** resp = NULL,char delim = 0);
int main2(void);

int main(void) {
  if(globus_module_activate(GLOBUS_COMMON_MODULE) != GLOBUS_SUCCESS) {
    fprintf(stderr,"COMMON module activation failed\n");
    exit(1);
  };
  if(globus_module_activate(GLOBUS_FTP_CONTROL_MODULE) != GLOBUS_SUCCESS) {
    fprintf(stderr,"FTP_CONTROL module activation failed\n");
    globus_module_deactivate(GLOBUS_COMMON_MODULE);
    exit(1);
  };

  main2();
  globus_module_deactivate(GLOBUS_FTP_CONTROL_MODULE);
  globus_module_deactivate(GLOBUS_COMMON_MODULE);
}

int main2(void) { 
  bool res = false;
  bool connected = false;
  bool authenticated = false;
  bool use_quit=false;
  char* resp;
  globus_ftp_control_host_port_t pasv_addr;
  globus_ftp_control_auth_info_t auth;
  globus_ftp_control_response_class_t resp_class;
  char* host = "grid.uio.no";
  unsigned short port = 2811;


  callback_status=CALLBACK_NOTREADY;
  if(globus_ftp_control_handle_init(&hctrl) != GLOBUS_SUCCESS) {
    cerr<<"Failed to init control handle"<<endl; return res;
  };
  globus_mutex_init(&wait_m,GLOBUS_NULL);
  globus_cond_init(&wait_c,GLOBUS_NULL);




  if(globus_ftp_control_connect(&hctrl,host,port,&resp_callback,NULL) !=
           GLOBUS_SUCCESS) {
    cerr<<"Failed connecting to server "<<host<<":"<<inttostring(port)<<endl;
  }
  else {
    if(wait_for_callback() == CALLBACK_DONE) {
      cerr<<"connected"<<endl;
      cerr<<"Quiting"<<endl;
      if(globus_ftp_control_force_close(&hctrl,&resp_callback,NULL) !=
//      if(globus_ftp_control_quit(&hctrl,&resp_callback,NULL) !=
             GLOBUS_SUCCESS) { cerr<<"Failed closing connection"<<endl; }
      else { wait_for_callback(); };
    };
  };

  globus_cond_destroy(&wait_c);
  globus_mutex_destroy(&wait_m);
  globus_ftp_control_handle_destroy(&hctrl);
  return res;
}

static int wait_for_callback(void) {
  int res;
  globus_mutex_lock(&wait_m);
  while(callback_status==CALLBACK_NOTREADY) {
    globus_cond_wait(&wait_c,&wait_m);
  };
  res=callback_status;
  callback_status=CALLBACK_NOTREADY;
  globus_mutex_unlock(&wait_m);
  return res;
}

static void resp_callback(void *arg,globus_ftp_control_handle_t *h,globus_object_t *error,globus_ftp_control_response_t *response) {
  globus_mutex_lock(&wait_m);
  if(error != GLOBUS_SUCCESS) {
    callback_status=CALLBACK_ERROR;
    char* tmp = globus_object_printable_to_string(error);
    cerr<<"Failure: "<<tmp<<endl; free(tmp);
    cerr<<"Server said: "<<response->response_buffer<<endl;
  }
  else {
    if(arg != 0) globus_ftp_control_response_copy(response,(globus_ftp_control_response_t*)arg);
    callback_status=CALLBACK_DONE;
  };
//  globus_ftp_control_response_destroy(response);
  globus_cond_signal(&wait_c);
  globus_mutex_unlock(&wait_m);
}

