#include "lister.h"
#include "../misc/log_time.h"

static int url_to_path(string &s) {
  int n = s.find(':');
  if( n == string::npos) return -1;
  n++; if(n >= s.length()) return -1; if(s[n] != '/') return -1;
  n++; if(n >= s.length()) return -1; if(s[n] != '/') return -1;
  n++; n=s.find('/',n); if(n == string::npos) n=s.length();
  s.erase(0,n);
  return 0;
}

int list_recursively(const string &url,list<string> &names, const string &add_path = "") {
  static Lister *lister = NULL;
  static int depth;
  if(add_path.length() == 0) {
    depth=0;
    lister = new Lister;
    if((!lister) || (!(*lister))) {
      odlog(0)<<"Problem initializing Lister"<<endl;
      return 1;
    };
  }
  else {
    depth++;
    if(depth >= 20) return -1;
  };
  if(lister->retrieve_dir(url+add_path) != 0) {
    odlog(0)<<"List not retrieved: "<<url+add_path<<endl; return -1;
  };
  /* check if directory or file */
  if(lister->size() == 1) {
    string path=url+add_path;
    url_to_path(path);
    if(path == (*(lister->begin()))) { /* file */
      names.push_back(add_path);
      depth--;
      if(add_path.length() == 0) { delete lister; };
      return 0;
    };
  };
  /* directory(ies) */
  {
    list<string> tnames;
    for(list<string>::iterator i=lister->begin();i!=lister->end();++i) {
      tnames.push_back(*i);
    };
    for(list<string>::iterator i=tnames.begin();i!=tnames.end();++i) {
      string add_path_=add_path+'/'+(*i);
      list_recursively(url,names,add_path_);
    };
  };
  depth--;
  if(add_path.length() == 0) { delete lister; };
  return 0;
}



int main(void) {
  globus_module_activate(GLOBUS_COMMON_MODULE);
  globus_module_activate(GLOBUS_FTP_CONTROL_MODULE);
  list<string> fnames;
  int res = list_recursively("gsiftp://dc1.uio.no/dc1",fnames,"");
  if(res != 0) {
    cerr<<"retrieve_dir failed"<<endl; return 1;
  };
  return 0;
}
